<?php
// Prüfen, ob der Dateiname mit einem Datum im gewünschten Format beginnt (YYMMDD-HHMM oder YYMMDD_HHMM)
        if (preg_match('/^(\d{2})(\d{2})(\d{2})[-_](\d{4})/', $file_name, $matches)) {
            // Extrahiere Jahr, Monat, Tag, Stunde und Minute
            $file_year = $matches[1];   // Jahr (z.B. "21" wird zu "2021")
            $file_month = $matches[2];          // Monat
            $file_day = $matches[3];            // Tag
            $file_hour = substr($matches[4], 0, 2); // Stunde (erste zwei Zeichen)
            $file_minute = substr($matches[4], 2, 2); // Minute (letzte zwei Zeichen)

            // Entferne Datum und Uhrzeit aus dem Dateinamen, also den Anfang
            $file_title = substr($file_name, strlen($matches[0])); // Rest des Dateinamens nach Datum/Uhrzeit

            // Überprüfen, ob eine Dateiendung existiert
            // if (pathinfo($file_title, PATHINFO_EXTENSION)) {
            //     // Entferne die Dateiendung, wenn sie existiert
            //     $file_title = pathinfo($file_title, PATHINFO_FILENAME);
            // }

            // Finde die Position des letzten Punktes im Dateinamen
            $last_dot_position = strrpos($file_title, '.');

            // Überprüfe, ob ein Punkt im Dateinamen existiert
            if ($last_dot_position !== false) {
                // Extrahiere den Dateinamen ohne die Erweiterung (alles vor dem letzten Punkt)
                $file_title = substr($file_title, 0, $last_dot_position);
            }

            // Entferne alles nach dem '@' (falls vorhanden)
            $file_title = strtok($file_title, '@');


            // Entferne einen führenden Unterstrich (falls vorhanden)
            $file_title = ltrim($file_title, '_');
            
        } else {
        }